/*
 *  Lightweight Embedded XML-RPC Server initialization functions
 *
 *  mtj@cogitollc.com
 *
 */

#include <string.h>
#include "userfunc.h"
#include "errors.h"

methodEntry_t methods[MAX_METHODS];
int methodMax = 0;


int callUserFunc( xmlCall_t *xmlCall )
{
  int i, ret = XML_NO_SUCH_FUNCTION;

  /* Find a function name match */
  for (i = 0 ; i < methodMax ; i++) {

    if (xmlCall->methodName[0] == methods[i].methodName[0]) {
      if (!strcmp(xmlCall->methodName, methods[i].methodName)) {
        ret = methods[i].func( xmlCall );
        break;
      }
    }

  }

  return ret;
}


int addMethod( int (*func)(xmlCall_t *), char *name )
{
  if (methodMax == MAX_METHODS) return -1;

  strcpy( methods[methodMax].methodName, name );
  methods[methodMax].func = func;

  methodMax++;

  return 0;
}


void userInit( void )
{
  int ret;

  ret = addMethod( getDeviceStats, "getDeviceStats" );

  /* Add your new methods here */
}  

/*
 *  Copyright (c) 2002 Cogito LLC.  All rights reserved.
 * 
 *  Redistribution and use in source and binary forms, with or 
 *  without modification, is hereby granted without fee provided 
 *  that the following conditions are met:
 * 
 *    1.  Redistributions of source code must retain the above 
 *        copyright notice, this list of conditions and the 
 *        following disclaimer.
 *    2.  Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the 
 *        following disclaimer in the documentation and/or other 
 *        materials provided with the distribution.
 *    3.  Neither the name of Cogito LLC nor the names of its 
 *        contributors may be used to endorse or promote products 
 *        derived from this software without specific prior 
 *        written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY COGITO LLC AND CONTRIBUTERS 'AS IS' 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED 
 * TO, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL COGITO LLC 
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARAY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 */

